std::unique_ptr< _Tp, _Dp >(3cxx)

NAME
std::unique_ptr< _Tp, _Dp > - 20.7.1.2 unique_ptr for single objects.

SYNOPSIS

  Public Types

template<typename _Up , typename _Ep > using __safe_conversion_up = __and_< is_convertible< typename unique_ptr< _Up, _Ep >::pointer, pointer >, __not_< is_array< _Up > >, __or_< __and_< is_reference< deleter_type >, is_same< deleter_type, _Ep > >, __and_< __not_< is_reference< deleter_type > >, is_convertible< _Ep, deleter_type > > > >
typedef _Dp deleter_type
typedef _Tp element_type
typedef _Pointer::type pointer

  Public Member Functions

constexpr unique_ptr () noexcept
Default constructor, creates a unique_ptr that owns nothing.
unique_ptr (pointer __p) noexcept
unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type &>::type __d) noexcept
unique_ptr (pointer __p, typename remove_reference< deleter_type >::type &&__d) noexcept
constexpr unique_ptr (nullptr_t) noexcept
Creates a unique_ptr that owns nothing.
unique_ptr (unique_ptr &&__u) noexcept
Move constructor.
template<typename _Up , typename _Ep , typename = _Require< __safe_conversion_up<_Up, _Ep>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>> unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
Converting constructor from another type.
template<typename _Up , typename > unique_ptr (auto_ptr< _Up > &&__u) noexcept
unique_ptr (const unique_ptr &)=delete
~unique_ptr () noexcept
Destructor, invokes the deleter if the stored pointer is not null.
pointer get () const noexcept
Return the stored pointer.
deleter_type & get_deleter () noexcept
Return a reference to the stored deleter.
const deleter_type & get_deleter () const noexcept
Return a reference to the stored deleter.
operator bool () const noexcept
Return true if the stored pointer is not null.
add_lvalue_reference< element_type >::type operator* () const
Dereference the stored pointer.
pointer operator-> () const noexcept
Return the stored pointer.
unique_ptr & operator= (unique_ptr &&__u) noexcept
Move assignment operator.
template<typename _Up , typename _Ep > enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
Assignment from another type.
unique_ptr & operator= (nullptr_t) noexcept
Reset the unique_ptr to empty, invoking the deleter if necessary.
unique_ptr & operator= (const unique_ptr &)=delete
pointer release () noexcept
Release ownership of any stored pointer.
void reset (pointer __p=pointer()) noexcept
Replace the stored pointer.
void swap (unique_ptr &__u) noexcept
Exchange the pointer and deleter with another object.

Detailed Description

  template<typename _Tp, typename _Dp = default_delete<_Tp>>
class std::unique_ptr< _Tp, _Dp >" 20.7.1.2 unique_ptr for single objects.

Definition at line 116 of file unique_ptr.h.

Constructor & Destructor Documentation

  template<typename _Tp, typename _Dp = default_delete<_Tp>> constexpr std::unique_ptr< _Tp, _Dp >::unique_ptr () [inline], [noexcept]

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 158 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p) [inline], [explicit], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type

The deleter will be value-initialized.

Definition at line 170 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type &>::type __d) [inline], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type
    __d A reference to a deleter.

The deleter will be initialized with __d

Definition at line 185 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p, typename remove_reference< deleter_type >::type && __d) [inline], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type
    __d An rvalue reference to a deleter.

The deleter will be initialized with std::move(__d)

Definition at line 197 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> constexpr std::unique_ptr< _Tp, _Dp >::unique_ptr (nullptr_t) [inline], [noexcept]

Creates a unique_ptr that owns nothing.

Definition at line 204 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (unique_ptr< _Tp, _Dp > && __u) [inline], [noexcept]

Move constructor.

Definition at line 209 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> template<typename _Up , typename _Ep , typename = _Require< __safe_conversion_up<_Up, _Ep>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>> std::unique_ptr< _Tp, _Dp >::unique_ptr (unique_ptr< _Up, _Ep > && __u) [inline], [noexcept]

Converting constructor from another type. Requires that the pointer owned by __u is convertible to the type of pointer owned by this object, __u does not own an array, and __u has a compatible deleter type.

Definition at line 223 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::~unique_ptr () [inline], [noexcept]

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 235 of file unique_ptr.h.

Member Function Documentation

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::get (void) const [inline], [noexcept]

Return the stored pointer.

Definition at line 307 of file unique_ptr.h.

Referenced by std::unique_ptr< _Tp[], _Dp >::swap().

  template<typename _Tp, typename _Dp = default_delete<_Tp>> deleter_type& std::unique_ptr< _Tp, _Dp >::get_deleter () [inline], [noexcept]

Return a reference to the stored deleter.

Definition at line 312 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> const deleter_type& std::unique_ptr< _Tp, _Dp >::get_deleter () const [inline], [noexcept]

Return a reference to the stored deleter.

Definition at line 317 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::operator bool () const [inline], [explicit], [noexcept]

Return true if the stored pointer is not null.

Definition at line 321 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> add_lvalue_reference<element_type>::type std::unique_ptr< _Tp, _Dp >::operator* () const [inline]

Dereference the stored pointer.

Definition at line 291 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::operator-> () const [inline], [noexcept]

Return the stored pointer.

Definition at line 299 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> unique_ptr& std::unique_ptr< _Tp, _Dp >::operator= (unique_ptr< _Tp, _Dp > && __u) [inline], [noexcept]

Move assignment operator.

Parameters:
    __u The object to transfer ownership from.

Invokes the deleter first if this object owns a pointer.

Definition at line 252 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> template<typename _Up , typename _Ep > enable_if< __and_< __safe_conversion_up<_Up, _Ep>, is_assignable<deleter_type&, _Ep&&> >::value, unique_ptr&>::type std::unique_ptr< _Tp, _Dp >::operator= (unique_ptr< _Up, _Ep > && __u) [inline], [noexcept]

Assignment from another type.

Parameters:
    __u The object to transfer ownership from, which owns a convertible pointer to a non-array object.

Invokes the deleter first if this object owns a pointer.

Definition at line 272 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> unique_ptr& std::unique_ptr< _Tp, _Dp >::operator= (nullptr_t) [inline], [noexcept]

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 281 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::release () [inline], [noexcept]

Release ownership of any stored pointer.

Definition at line 328 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> void std::unique_ptr< _Tp, _Dp >::reset (pointer __p = pointer()) [inline], [noexcept]

Replace the stored pointer.

Parameters:
    __p The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 342 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> void std::unique_ptr< _Tp, _Dp >::swap (unique_ptr< _Tp, _Dp > & __u) [inline], [noexcept]

Exchange the pointer and deleter with another object.

Definition at line 352 of file unique_ptr.h.

Referenced by std::unique_ptr< _Tp[], _Dp >::swap().

Author

Generated automatically by Doxygen for libstdc++ from the source code.